\chapter{Appendix-2} 
\label{ch:Appendix-2}
\section{CUBIT: Mesh Generation Script Template}
\label{App:CUBIT_code}
\# Delete existing mesh\newline
reset\newline
\# Specify the XYZ dimensions of the entire domain\newline
create brick x 0.008 y 0.008 z 0.0007\newline 
\# Move to make z=0 on surface and X and Y appropriately\newline
move volume 1 z -0.0004\newline
move volume 1 x +0.0025\newline
move volume 1 y +0.0025\newline
\# Number of spatial discretisation in X\newline
curve 2 4 6 8 interval 266\newline
\# Number of spatial discretisation in Y\newline
curve 1 3 5 7 interval 266\newline
\# Number of spatial discretization in Z\newline
curve 9 10 11 12 interval 28\newline
\# Specify sidesets that will help in mentioning Boundary Conditions while running the program\newline
sideset 1 surface 1\newline
sideset 2 surface 2\newline
sideset 3 surface 3\newline
sideset 4 surface 4\newline
sideset 5 surface 5\newline
sideset 6 surface 6\newline
preview mesh volume all\newline
mesh volume all\newline
block 1 volume 1\newline
block 1 element type HEX\newline
nodeset 100 volume all\newline
set large exodus file off\newline
\# export the mesh file *.exo to specified path Change the path in the following command\newline
export mesh "/home/n22/block.exo" block 1 overwrite\newline

\section{Python script to filter G and R at interface}
\label{App:GR_python}
\begin{lstlisting}[language=Python]
#!/usr/bin/python

import os
import sys
sys.path.append('/home/n22/softwares/visit/2_10/2.10.2/linux-x86_64/lib/site-packages')
from visit import * 
import glob

LaunchNowin()
# Construct Thermal Gradient vector and filter the thermal gradient at the liquid solid interface and the liquid solid interface velocity with help of cooling rate
OpenDatabase("MAIN-data.*.gmv database", 0)
DefineScalarExpression("Cooling_Rate", "(<dT/dt>)")
DefineVectorExpression("Thermal_Gradient_Vector", "{<dT/dx>,<dT/dy>,<dT/dz>}")
DefineScalarExpression("Thermal_Gradient_Magnitude", "magnitude(Thermal_Gradient_Vector)")
DefineScalarExpression("Thermal_Gradient_Interface", "if(and(and(lt(T,1610), gt(T,1600)),lt(Cooling_Rate,0)), abs(Thermal_Gradient_Magnitude), 0)")
DefineScalarExpression("LS_Interface_Velocity", "if(and(and(lt(T,1610), gt(T,1600)),gt(Thermal_Gradient_Magnitude,1)), abs(Cooling_Rate/(Thermal_Gradient_Magnitude)), 0)")

#Calculate number of time states
n=TimeSliderGetNStates()-1;
#Check for complete solidification
TS = open("Timestates.txt", "wb+")
TS.write(str(n));
TS.close()
AddPlot("Pseudocolor", "T")
DrawPlots()
SetTimeSliderState(n)
Query("Max")
max_temp = GetQueryOutputValue()
MT = open("max_temp.txt", "wb+")
MT.write(str(max_temp)+" K"+" is the maximum temperature at the final time step of the simulation");
MT.close()
if max_temp > 1610:
    ER = open("postprocessing_failure.txt", "wb+")
    ER.write("PostProcessing has been terminated prematurely.\nMelt pool has not solidified completely when simulation ended. Try increasing bounds of Output_T in the simulation input file.\nMaximum Temperature at the last time step is: "+str(max_temp)+" K");
    ER.close()
    sys.exit()

#Export Interface Velocity in XYZ(.okc) format
DeleteAllPlots()
AddPlot("Pseudocolor","LS_Interface_Velocity")
DrawPlots()
for i in range(TimeSliderGetNStates()):
    SetActiveWindow(1)
    SetTimeSliderState(i)
    ExportDBAtts = ExportDBAttributes()
    ExportDBAtts.db_type = "Xmdv"
    ExportDBAtts.filename = "R%04d" %i
    ExportDBAtts.dirname = "."
    ExportDBAtts.variables = ("LS_Interface_Velocity")
    ExportDBAtts.opts.types = ()
    ExportDatabase(ExportDBAtts)

# Export Interface Thermal Gradient in XYZ (.okc) format
DeleteAllPlots()
AddPlot("Pseudocolor","Thermal_Gradient_Interface")
DrawPlots()
for i in range(TimeSliderGetNStates()):
    SetActiveWindow(1)
    SetTimeSliderState(i)
    ExportDBAtts = ExportDBAttributes()
    ExportDBAtts.db_type = "Xmdv"
    ExportDBAtts.filename = "G%04d" %i
    ExportDBAtts.dirname = "."
    ExportDBAtts.variables = ("Thermal_Gradient_Interface")
    ExportDBAtts.opts.types = ()
    ExportDatabase(ExportDBAtts)

sys.exit()

\end{lstlisting}
